package nsf;

import java.util.Hashtable;
import org.sanskritlibrary.SAXParser;
import org.sanskritlibrary.SAXParserHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class EncodingMap implements SAXParserHandler {
    Locator locator;
    int[] map = new int[256];
    String filename;
    SAXParser sp;
    int tdCount = 0;
    int currentChar = 0;
    StringBuilder sb = new StringBuilder();

    public EncodingMap(String filename) throws Exception {
        try {
            this.filename = filename;
            sp = new SAXParser(this);
            sp.parse(filename);
        } catch (Exception ex) {
            System.out.format("In EncodingMap, %s\n", ex.getMessage());
            throw ex;
        }
    }

    public int[] getMap () {
        return map;
    }

    
    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        System.out.format("EncodingMap, fatalError: %s\n", exception.getException().getMessage());
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {
    }

    public void endDocument() throws SAXException {
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        if (qName.equals("tr")) {
            tdCount = 0;
            sb.setLength(0);
            currentChar = -1;
        } else if (qName.equals("td")) {
            tdCount++;
            sb.setLength(0);
        }
    }

    public void endElement(String uri, String localName, String qName) throws SAXException {
        if (qName.equals("td")) {
            if (tdCount == 2) {
                currentChar = Integer.parseInt(sb.toString().trim());
            } else if (tdCount == 3) {
                map[currentChar] = Integer.parseInt(sb.toString().trim());
            }
        }
    }

    public void characters(char[] ch, int start, int length) throws SAXException {
        if (tdCount == 2 || tdCount == 3) {
            sb.append(new String(ch, start, length));
        }
    }

}
