package nsf;

import java.util.Comparator;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Enumeration;
import org.sanskritlibrary.FSM;
import org.sanskritlibrary.ResourceInputStream;
import org.sanskritlibrary.webservice.TransformMap;
import org.sanskritlibrary.webservice.WebServices;
import org.sanskritlibrary.TextFormatter;

public class AccentBlock implements Comparator
{
    static Hashtable<String, FSM[]> fmsh = new Hashtable<String, FSM[]>();
    static ResourceInputStream ris = null;
    static TransformMap tm = null;
    public char letter;
    public String SLP2;
    public String sortField;
    public String accent;
    public String line;
    public boolean contextFree = false;
    public int sortType = 0;

    static void setResourceInputStream(ResourceInputStream _ris) throws Exception
    {
        ris = _ris;
        tm = new TransformMap("*:slp1->dn", ris, fmsh);
    }

    static String checkContextFree(ArrayList<AccentBlock> a, AccentBlock _ab)
    {
        String rc = "";

        for (AccentBlock ab : a)
        {
            if (ab.accent.equals(_ab.accent) && !ab.sortField.equals(_ab.sortField))
            {
                rc = ab.SLP2;
                break;
            }
        }

        return rc;
    }

    static void setContextFreeField(ArrayList<AccentBlock> a)
    {
        Hashtable<String, String> defaultTarget = new Hashtable<String, String>();
        Hashtable<String, Integer> h = new Hashtable<String, Integer>();

        for (AccentBlock ab : a)
        {
            if (defaultTarget.get(ab.accent) == null)
            {
                h.clear();
                for (AccentBlock ab2 : a)
                {
                    if (ab2.accent.equals(ab.accent))
                    {
                        int cnt = 0;
                        if (h.get(ab2.sortField) != null)
                            cnt = h.get(ab2.sortField);
                        cnt++;
                        h.put(ab2.sortField, cnt);
                    }
                }
                Enumeration<String> e = h.keys();
                int max = 0;
                String best = null;
                while (e.hasMoreElements())
                {
                    String key = e.nextElement();
                    int cnt = h.get(key);
                    if (cnt > max)
                    {
                        max = cnt;
                        best = key;
                    }
                }

                defaultTarget.put(ab.accent, best);
            }

            String sf = defaultTarget.get(ab.accent);
            ab.contextFree = sf.equals(ab.sortField);
        }
    }

    public AccentBlock(int sortType)
    {
        this.sortType = sortType;
    }

    public AccentBlock(String s) throws Exception
    {
        String[] fields = s.split("\t");

        this.letter = fields[1].charAt(0);
        String dn = WebServices.transformString(fields[1].substring(0,1), tm);
        dn = dn.replace("\\.", "\\\\.");
        String pattern = "\\{\\\\skt " + dn;
        this.sortField = fields[2].replaceAll(pattern, "");
        this.accent = fields[1].substring(1);
        this.line = s;
        this.SLP2 = TextFormatter.toHexString(fields[0], 3);
        if (this.SLP2.equals("242"))
            this.SLP2 = "242";
    }

    public int compare(Object o1, Object o2)
    {
        AccentBlock ab1 = (AccentBlock)o1;
        AccentBlock ab2 = (AccentBlock)o2;
        if (sortType == 1)
            return ab1.accent.compareTo(ab2.accent);
        else if (sortType == 2)
            return ab1.sortField.compareTo(ab2.sortField);
        else
            return 0;
    }

}
