package nsf;

import java.util.Comparator;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Enumeration;
import org.sanskritlibrary.TextFormatter;

public class AccentInfo implements Comparator
{
	public String accent;
	public int count;
	public Hashtable[] variations = new Hashtable[9];

	public AccentInfo()
	{
	}
	
	public AccentInfo(String accent, int count)
	{
		this.accent = accent;
		this.count = count;
	}

	public int compare(Object arg0, Object arg1)
	{
		AccentInfo ai1 = (AccentInfo) arg0;
		AccentInfo ai2 = (AccentInfo) arg1;
		return ai1.accent.compareTo(ai2.accent);
	}

	public boolean setVariation(int n, String s)
	{
		boolean rc = true;
		Hashtable h = variations[n];
		if (h == null)
		{
			h = new Hashtable();
			variations[n] = h;
		}
		h.put(s, "x");
		return rc;
	}

	@Override
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		sb.append(String.format("%s[%d] ", accent, count));
		for (int i=0; i<variations.length; i++)
		{
			if (variations[i] != null)
			{
				Hashtable h = variations[i];
				Enumeration e = h.keys();
				if (h.size() == 1)
				{
					String s = (String)e.nextElement();
					sb.append(String.format("(%d)%s ", i, TextFormatter.charToSlashU(s)));
				}
				else
				{
					String delim = "";
					StringBuilder sbb = new StringBuilder();
					while(e.hasMoreElements())
					{
						String s = TextFormatter.charToSlashU((String)e.nextElement());
						sbb.append(String.format("%s%s", delim, s));
						delim = ", ";
					}
					sb.append(String.format("***(%d)%s ", i, sbb.toString()));
				}
			}
		}

		return sb.toString();
	}
}
