package nsf;

import java.io.BufferedWriter;
import org.sanskritlibrary.IOAssistance;

public class CacheTest {
    private static final int CACHE_LENGTH = 8;
    char[] outputCache = new char[CACHE_LENGTH];
    char[] inputCache = new char[CACHE_LENGTH];
    int outputCurrent = 0;
    int inputCurrent = 0;
    int inputStart = 1;
    BufferedWriter out;

    public CacheTest (String filename) throws Exception {
        out = IOAssistance.openWriter(filename);

        cachedWrite("abcdefghijklmnopqrstuvwxyz1");      // should see cdefghij
        System.out.println(getCachedWrite());
        out.close();
    }

    void cachedWrite(String s) throws Exception {
        int slen = s.length();
        for (int i=0; i<slen; i++) {
            outputCache[outputCurrent] = s.charAt(i);
            outputCurrent = (outputCurrent+1)%CACHE_LENGTH;
        }
        out.write(s);
    }

    void cachedWrite(char ch) throws Exception {
        outputCache[outputCurrent] = ch;
        outputCurrent = (outputCurrent+1)%CACHE_LENGTH;
        out.write(ch);
    }

    String getCachedWrite() {
        StringBuilder sb = new StringBuilder(CACHE_LENGTH);
        for (int i=0, j=outputCurrent; i<CACHE_LENGTH; i++) {
            char ch = outputCache[j];
            if (ch != 0) {
                sb.append(ch);
            }
            j = (j+1) % CACHE_LENGTH;
        }
        return sb.toString();
    }
}
