package nsf;

import java.io.File;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.ext.DefaultHandler2;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.Regex;

public class CompareAnnotations extends DefaultHandler2 //implements ErrorHandler, ContentHandler, DTDHandler, EntityResolver
{
    static Hashtable<String, Integer> h = new Hashtable<String, Integer>();
    static int emptyCount = 0;
    Locator locator;
    AnnotationInfo ai;
    AnnotationItem currentItem;
    public CompareAnnotations(String filename) throws Exception
    {
        // Use the default (non-validating) parser
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try
        {
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse(new File(filename), this);
        }
        catch (Throwable t)
        {
            t.printStackTrace ();
        }
    }


    // For ErrorHandler
    @Override
    public void warning(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void error(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void fatalError(SAXParseException exception) throws SAXException
    {
        throw exception;
    }

    // For ContentHandler
    @Override
    public void setDocumentLocator(Locator locator)
    {
        this.locator = locator;
    }

    @Override

    public void startDocument() throws SAXException
    {
        ai = new AnnotationInfo();
    }

    @Override
    public void endDocument() throws SAXException
    {
    }

    @Override
    public void startPrefixMapping(String prefix, String uri) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void endPrefixMapping(String prefix) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
        if (qName.equals("annotations")) {
            currentItem = null;
            ai.page = atts.getValue("page");
        } else if (qName.equals("annotation")) {
            currentItem = new AnnotationItem();
            ai.items.add(currentItem);
            currentItem.start = atts.getValue("start");
            currentItem.end = atts.getValue("end");
            currentItem.x1 = atts.getValue("x1");
            currentItem.y1 = atts.getValue("y1");
            currentItem.x2 = atts.getValue("x2");
            currentItem.y2 = atts.getValue("y2");
            currentItem.type = atts.getValue("type");
        }
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
    }


    @Override
    public void characters(char[] ch, int start, int length) throws SAXException
    {
        if (currentItem != null) {
            currentItem.comment += new String(ch, start, length);
        }
    }

    static void CompareFiles () throws Exception {
        String[] directories = new String[] {
"MBh01AdiParva",
"MBh01AdiParvan",

"MBh02SabhaParva",
"MBh02SabhaParvan",

"MBh03VanaParva",
"MBh03VanaParvan",

"MBh05UdyogaParva",
"MBh05UdyogaParvan",

"MBh06BhishmaParva",
"MBh06BhishmaParvan",

"MBh07DronaParva",
"MBh07DronaParvan",

"MBh11StriParva",
"MBh11StriParvan",

"MBh12ShantiParva",
"MBh12ShantiParvan",

"MBh13AnusasanaParva",
"MBh13AnusasanaParvan",

"MBh14AshvamedhikaParva",
"MBh14AshvamedhikaParvan",

"MBh15AshramavasikaParva",
"MBh15AshramavasikaParvan",

"MBh16MausalaParva",
"MBh16MausalaParvan",

"MBh17MahaprasthanikaParva",
"MBh17MahaprasthanikaParvan",

"MBh18SvargarohanaParva",
"MBh18SvargarohanaParvan",
    };
        
    String dir = "C:/Users/ralph/Documents/temp/annotations-5-10-2011/annotations/";
        int len = directories.length;
        /*
        for (int i=0; i<len; i+=2) {
            compareDirectories(dir + directories[i], dir + directories[i+1]);
            compareDirectories(dir + directories[i+1], dir + directories[i]);
        }

        Enumeration<String> en = h.keys();
        while (en.hasMoreElements()) {
            String key = en.nextElement();
            Integer count = h.get(key);
            System.out.format("%s: %d\n", key, count.intValue());
        }
        */

        for (int i=0; i<len; i+=2) {
            compareFiles(dir + directories[i], dir + directories[i+1]);
        }
    }

    private static void compareDirectories (String dir01, String dir02) throws Exception{
        File[] files = new File(dir01).listFiles();
        for (File file : files) {
            if (file.isDirectory()) {
                File[] files02 = file.listFiles();
                for (File file02 : files02) {
                    if (file02.isDirectory()) {
                        compareDirectories(
                                dir01 + "/" + file.getName() + "/" + file02.getName(),
                                dir02 + "/" + file.getName() + "/" + file02.getName());
                    }
                }
            } else {
                String f2 = String.format("%s/%s", dir02, file.getName());

                if (new File(f2).exists()) {
                    if (file.getName().endsWith(".xml")) {
                        CompareAnnotations ca = new CompareAnnotations(file.getAbsolutePath());
                        if (ca.ai.items.size() == 0) {
                            Integer count = h.get(dir01);
                            if (count == null) {
                                count = new Integer(1);
                            } else {
                                count = new Integer(count.intValue() + 1);
                            }
                            h.put(dir01, count);
                            continue;
                        }
                    }
                    System.out.format("%s is in %s but not in %s\n", file.getName(), dir01, dir02);
                } else {
                }
            }
        }
    }

    private static void compareFiles (String dir01, String dir02) throws Exception{
        File[] files = new File(dir01).listFiles();
        for (File file : files) {
            if (file.isDirectory()) {
                File[] files02 = file.listFiles();
                for (File file02 : files02) {
                    if (file02.isDirectory()) {
                        compareFiles(
                                dir01 + "/" + file.getName() + "/" + file02.getName(),
                                dir02 + "/" + file.getName() + "/" + file02.getName());
                    }
                }
            } else {
                String f2 = String.format("%s/%s", dir02, file.getName());

                if (new File(f2).exists()) {
                    if (file.getName().endsWith(".xml")) {
                        CompareAnnotations ca01 = new CompareAnnotations(file.getAbsolutePath());
                        CompareAnnotations ca02 = new CompareAnnotations(f2);
                        compare(file.getAbsolutePath(), f2, ca01.ai.items, ca02.ai.items);
                    }
                } else {
                }
            }
        }
    }

    private static void compare(String f1, String f2, ArrayList<AnnotationItem> a1, ArrayList<AnnotationItem> a2) {
        if (a1.size() != a2.size()) {
                dump(f1, f2);
        } else {
            int len = 0;
            len = a1.size();
            for (int i=0; i<len; i++) {
                if (!compareItem(a1.get(i), a2.get(i))) {
                    dump(f1, f2);
                    return;
                }
            }
        }
    }

    private static boolean compareItem(AnnotationItem a1, AnnotationItem a2) {

        if (!cmp(a1.type, a2.type))
            return false;

        if (!cmp(a1.x1, a2.x1))
            return false;

        if (!cmp(a1.y1, a2.y1))
            return false;

        if (!cmp(a1.x2, a2.x2))
            return false;

        if (!cmp(a1.y2, a2.y2))
            return false;

        if (!cmp(a1.comment, a2.comment)) {
            Regex re1 = new Regex(a1.comment, "<!\\[CDATA\\[(.*)\\]\\]");
            Regex re2 = new Regex(a2.comment, "<!\\[CDATA\\[(.*)\\]\\]");
            if (re1.find()) {
                a1.comment = re1.getGroup(1);
            }
            if (re2.find()) {
                a2.comment = re2.getGroup(1);
            }
            return cmp(a1.comment, a2.comment);
        }

        return true;
    }

    private static boolean cmp(String s1, String s2) {
        if (s1 == null && s2 == null) {
            return true;
        }

        return ! ((s1 == null && s2 != null) ||
               (s1 != null && s2 == null) ||
               !s1.equals(s2));
    }

    private static void dump (String f1, String f2) {
        try {
            String s = IOAssistance.readEntireFile(f1);
            System.out.format("1.***%s:\n%s\n", f1, s);
            s = IOAssistance.readEntireFile(f2);
            System.out.format("2.***%s:\n%s\n", f2, s);
            System.out.println("--------------------------\n\n");
            } catch (Exception ex) {
                System.out.println(ex.getMessage());
            }
    }
    public class AnnotationInfo {
        String page;
        ArrayList<AnnotationItem> items = new ArrayList<AnnotationItem>();
    }

    public class AnnotationItem {
        String type;
        String x1;
        String y1;
        String x2;
        String y2;
        String start;
        String end;
        String comment = "";
    }
}
