package nsf;

import org.sanskritlibrary.SAXParserHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.sanskritlibrary.SAXParser;

public class ManuscriptTypes implements SAXParserHandler {
    private String mtype = null;
    private StringBuilder currentBuffer = new StringBuilder();
    private String filename;
    private SAXParser saxParser;
    private Locator locator;

    public ManuscriptTypes (String filename) {
        saxParser = new SAXParser(this);
        this.filename = filename;
    }


    public void parse () throws Exception {
        saxParser.parse(filename);
    }

    
    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {
    }

    public void endDocument() throws SAXException {
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        if (qName.equals("manuscript")) {
            mtype = atts.getValue("type");
        }
    }

    public void endElement(String uri, String localName, String qName) throws SAXException {
        if (qName.equals("directoryName")) {
            System.out.format("%s,%s\n", currentBuffer.toString().trim(), mtype);
        }
        currentBuffer.setLength(0);
    }

    public void characters(char[] ch, int start, int length) throws SAXException {
        currentBuffer.append(new String(ch, start, length));
    }

}
