package nsf;

public class MarcRecord
{
    public String leader;           // collection.record.leader
    public String control001;       // collection.record.controlfield[tag="001"]
    public String control008;       // collection.record.controlfield[tag="008"]
    public String datafield035;     // collection.record.datafield[tag="035"].subfield[code="a"];
    public String datafield079;     // collection.record.datafield[tag="079"].subfield[code="a"];
    public String datafield773;     // collection.record.datafield[tag="773"].subfield[code="g"];

    public void clear()
    {
        leader = "";
        control001 = "";
        control008 = "";
        datafield035 = "";
        datafield079 = "";
        datafield773 = "";
    }

    public void setLeader(String s)
    {
        leader += s;
    }

    public void setControl001(String s)
    {
        control001 += s;
    }

    public void setControl008(String s)
    {
        control008 += s;
    }

    public void setDatafield035(String s)
    {
        datafield035 += s;
    }

    public void setDatafield079(String s)
    {
        datafield079 += s;
    }

    public void setDatafield773(String s)
    {
        datafield773 += s;
    }

    public String getDatafield773()
    {
        if (datafield773.length() > 5)
            datafield773 = datafield773.substring(5);           // get rid of Item

        if (datafield773.length() < 4)
            datafield773 = "000".substring(0, 4 - datafield773.length()) + datafield773;  // pad with leading zeroes to make length 4

        return datafield773;
    }



    @Override
    public String toString()
    {
        StringBuilder sb = new StringBuilder();
        sb.append(String.format("leader: %s\n", leader));
        sb.append(String.format("control001: %s\n", control001));
        sb.append(String.format("control008: %s\n", control008));
        sb.append(String.format("catafield035: %s\n", datafield035));
        sb.append(String.format("datafield079: %s\n", datafield079));
        sb.append(String.format("datafield773: %s\n", datafield773));

        return sb.toString();
    }
}
