/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nsf;

import java.util.Hashtable;
import java.io.BufferedWriter;
import org.sanskritlibrary.webservice.TransformMap;
import org.sanskritlibrary.PassThroughParser;
import org.sanskritlibrary.SymbolParser;
import org.sanskritlibrary.Rules;
import org.sanskritlibrary.RTF2;
import org.sanskritlibrary.Regex;
import org.sanskritlibrary.IOAssistance;
/**
 *
 * @author ralph
 */
public class RTFPreprocess extends RTFRoot
{
    String fileName;
    String platform;

    public RTFPreprocess(String fileName, String platform)
    {
        this.fileName = fileName;
        this.platform = platform;
    }

    public void parse() throws Exception
    {
        parseRTFFile(fileName);
//        rtfFormat(fileName.replace(".rtf", "y.rtf"));

    }

    public void parseRTFFile(String fileName) throws Exception
    {
        Hashtable<String, TransformMap> map = new Hashtable<String, TransformMap>();
        try
        {
            SymbolParser symp = new SymbolParser();
            PassThroughParser pt = new PassThroughParser();
            Rules rules = new Rules();
            rules.add("fonttbl", pt);
            rules.add("stylesheet", pt);
            rules.add("colortbl", pt);
            rules.add("themedata", pt);
            rules.add("colorschememapping", pt);
            rules.add("latentstyles", pt);
            rules.add("datastyles", pt);
            rules.add("f", pt);
            rules.add("af", pt);
            rules.add("deff", pt);
            rules.add("adeff", pt);
            rules.add("dn", pt);
            rules.add("field", symp);
            parseRTF(fileName, rules, map);
        } catch (Exception ex)
        {
            System.out.println(RTF2.debug);
            throw ex;
        }

    }

    public void parseRTF(String fileName, Rules rules,
            Hashtable<String, TransformMap> map) throws Exception
    {
        String outFileName = Regex.replace(fileName, "\\.rtf$", "y.rtf");
        BufferedWriter bw = IOAssistance.openWriter(outFileName);
        RTF2 rtf = new RTF2(fileName, rules, map, bw, platform, null);

        String logFile = outFileName + ".log";
        BufferedWriter log = IOAssistance.openWriter(logFile);
        rtf.setLog(log);

        System.out.format("Removing symbols %s\n", rtf.getFile().getName());
        rtf.removeSymbols();
        rtf.close();
    }
}
