package nsf;

import java.util.Hashtable;
import java.util.ArrayList;
import java.io.File;
import java.io.IOException;
import java.io.OutputStreamWriter;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;
//import org.xml.sax.EntityResolver;
//import org.xml.sax.DTDHandler;
//import org.xml.sax.ContentHandler;
//import org.xml.sax.ErrorHandler;

import javax.xml.parsers.SAXParserFactory;
//import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

public class SAXTest extends DefaultHandler //implements ErrorHandler, ContentHandler, DTDHandler, EntityResolver
{
    String currentDirectory;
    Locator locator;
    OutputStreamWriter out;
    Hashtable<String, ArrayList<String>> files;
    public SAXTest(String fileName, Hashtable<String, ArrayList<String>> files)
    {
        this.files = files;
        // Use the default (non-validating) parser
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try
        {
            // Set up output stream
            out = new OutputStreamWriter (System.out, "UTF8");

            // Parse the input
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( new File(fileName), this);

        }
        catch (Throwable t)
        {
            t.printStackTrace ();
        }


    }

    // For ErrorHandler
    @Override
    public void warning(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void error(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void fatalError(SAXParseException exception) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    // For ContentHandler
    @Override
    public void setDocumentLocator(Locator locator)
    {
        this.locator = locator;
    }

    @Override

    public void startDocument() throws SAXException
    {
    }

    @Override
    public void endDocument() throws SAXException
    {
    }

    @Override
    public void startPrefixMapping(String prefix, String uri) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void endPrefixMapping(String prefix) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException
    {
        if (qName.equals("directory"))
        {
            currentDirectory = atts.getValue("name");
            if (currentDirectory == null)
                throw new SAXException("directory element does not have a name attribute");

            files.put(currentDirectory, new ArrayList<String>());
        }
        else if (qName.equals("page"))
        {
            ArrayList<String> a = files.get(currentDirectory);
            String filename = atts.getValue("name");
            if (filename == null)
                throw new SAXException("page element does not have a name attribute");
            else
                a.add(filename);
        }
    }

    @Override
    public void endElement(String uri, String localName, String qName) throws SAXException
    {
    }

    @Override
    public void characters(char[] ch, int start, int length) throws SAXException
    {
    }

    @Override
    public void ignorableWhitespace(char[] ch, int start, int length) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void processingInstruction(String target, String data) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void skippedEntity(String name) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    // For DTDHandler
    @Override
    public void notationDecl(String name, String publicId, String systemId) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void unparsedEntityDecl(String name, String publicId, String systemId, String notationName) throws SAXException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    // For EntityHandler
    @Override
    public InputSource resolveEntity(String publicId, String systemId) throws SAXException, IOException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    // Wrap I/O exceptions in SAX exceptions, to
    // suit handler signature requirements
    private void showData (String s) throws SAXException
    {
        try
        {
            out.write (s);
            out.flush ();
        }
        catch (IOException e)
        {
            throw new SAXException ("I/O error", e);
        }
    }

    // Start a new line
    private void newLine () throws SAXException
    {
        String lineEnd =  System.getProperty("line.separator");
        try
        {
            out.write (lineEnd);
        }
        catch (IOException e)
        {
            throw new SAXException ("I/O error", e);
        }
    }

}
