package nsf;
import java.util.Hashtable;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.sanskritlibrary.SAXParserHandler;
import org.sanskritlibrary.SAXParser;

public class TextMappingParser implements SAXParserHandler {
    private SAXParser saxParser;
    private String config;
    private Locator locator;
    private StringBuilder currentBuffer = new StringBuilder();
    private Hashtable<String, String> textMappings = new Hashtable<String, String>();
    private String textName =  null;

    public TextMappingParser (String config) {
        saxParser = new SAXParser(this);
        this.config = config;
    }

    public void parse () throws Exception {
        saxParser.parse(config);
    }

    public Hashtable<String, String> getTextMappings () {
        return textMappings;
    }
    
    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {
    }

    public void endDocument() throws SAXException {
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        if (qName.equals("textType")) {
            textName = atts.getValue("name");
        } else if (qName.equals("text")) {
            currentBuffer.setLength(0);
        }
    }

    public void endElement(String uri, String localName, String qName) throws SAXException {
        if (qName.equals("text")) {
            textMappings.put(textName, currentBuffer.toString().trim());
        }
        currentBuffer.setLength(0);
    }

    public void characters(char[] ch, int start, int length) throws SAXException {
        if (currentBuffer != null) {
            currentBuffer.append(new String(ch, start, length));
        }
    }
}
